﻿//Directive to implement HEADER
FrameworkApp.directive('headerBar', function ($rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl+'/header.html',
        link: function ($scope, $rootScope, elem, attrs) {

        }
    }
});

//Directive to implement PAGE CONTAINER
FrameworkApp.directive('pageContainer', function ($animate,$rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl+'/container.html',
        link: function ($scope, $rootScope, elem, attrs) {

        }
    }
});

//Directive to implement FOOTER
FrameworkApp.directive('footerBar', function ($rootScope) {
    return {
        restrict: 'C',
        templateUrl: '../html5/Views/ui/'+$rootScope.selectedLang+'/footer.html',
        link: function ($scope, $rootScope, elem, attrs) {

        }
    }
});

//Directive to implement MENU
FrameworkApp.directive('menuContainer', function ($rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl+'/menu.html',
        link: function ($scope, $rootScope, elem, attrs) {
        },
        controller: function ($scope) {
            $scope.closeMenu = function () {
                $('.menu-page-list .tree-toggler').parent().children('ul.tree').toggle(200);
                $('.menu').slideToggle(200);
                $(".resource-btn").css("pointer-events", "all");
                $(".help-btn").css("pointer-events", "all");
			//	$('.resource-btn').css('opacity','1');
				//$('.menu-btn').css('opacity','1');
            }
        }
    }
});

//Directive to implement MENU LIST inside MENU
FrameworkApp.directive('menuList', function () {
    return {
        restrict: 'A',
        scope: {
            isOpen: "=menuList" // 'data-slide-toggle' in our html
        },
        link: function (scope, element, attr) {
            var slideDuration = parseInt(attr.slideToggleDuration, 10) || 200;
            scope.$watch('isOpen', function (newIsOpenVal, oldIsOpenVal) {
                if (newIsOpenVal !== oldIsOpenVal) {
                    element.stop().slideToggle(slideDuration);

                }
                $('.menu-page-list .tree-toggler').parent().children('ul.tree').toggle(200, function(){
                    if ( $('.menu').css('display') == 'none'){
                        $(".resource-btn").css("pointer-events", "all");
                        $(".help-btn").css("pointer-events", "all");
						//$('.resource-btn').css('opacity','1');
						//$('.menu-btn').css('opacity','1');
                    }
                    else{
                        $(".resource-btn").css("pointer-events", "none");
                        $(".help-btn").css("pointer-events", "none");
						//$('.resource-btn').css('opacity','0.6');
						//$('.menu-btn').css('opacity','0.6');

                        var currentNode = $(".menu-page-list").find(".current-topic")
                        if(currentNode.attr('data-expand') != "false") {
                            currentNode.find("i").removeClass('fa-arrow-circle-o-down').addClass('fa-arrow-circle-o-up');
                            currentNode.next('.tree').slideDown();
                            $('.menu-page-list .tree').not(currentNode.next('.tree')).slideUp();
                        }
                    }

                });


            });
        }
    };
});

//Directive to implement MENU LIST inside MENU
FrameworkApp.directive('cogList', function () {
    return {
        restrict: 'A',
        scope: {
            isOpen: "=cogList" // 'data-slide-toggle' in our html
        },
        link: function (scope, element, attr) {
            var slideDuration = parseInt(attr.slideToggleDuration, 10) || 200;
            scope.$watch('isOpen', function (newIsOpenVal, oldIsOpenVal) {
                if (newIsOpenVal !== oldIsOpenVal) {
                    element.stop().slideToggle(slideDuration);
                }
                $('.cog-item .tree-toggler').parent().children('ul.tree').toggle(200);
            });
        }
    };
});

//Directive to implement MENU
FrameworkApp.directive('cogContainer', function ($rootScope) {
    return {
        restrict: 'C',
        templateUrl: $rootScope.deviceUrl+'/cog.html',
        link: function ($scope, $rootScope, elem, attrs) {
        },
        controller: function ($scope) {

        }
    }
});


FrameworkApp.directive('courseAssessment', function () {
    return {
        restrict: 'CA',
        link: function ($scope, $rootScope, elem, attrs) {
        },
        controller: function ($scope, $rootScope) {
			$rootScope.resumeLastPage = false;
			$rootScope.isPrevButtonDisabled = false;
			//$rootScope.asmntScoreArray = new Array(5);
			$rootScope.assesmentScore = 0;
            $rootScope.startAssessment = function(){
				$rootScope.checkInternet($rootScope.selectedLang);
				if(navigator.onLine){
					$rootScope.markVisitedPage();
					$rootScope.assesmentStarted = true;
					$rootScope.isNextButtonDisabled = true;
					$rootScope.isPrevButtonDisabled = true;
					$rootScope.assesmentScore = 0;
					console.log($rootScope.currentModule);
					$rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, 1);
              }
		   }
			$rootScope.assesmentQuestionIndex = [];
             setTimeout(function(){
                $rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading;
            },100)
			//$rootScope.CourseContent.pageHeading = $rootScope.CourseContent.pageHeading;
			console.log($rootScope.pageStatusList)
			if($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == 1){
				$rootScope.isNextButtonDisabled = false;
				setTimeout(function(){
					$(".next").addClass("done");
					$("#gInstruct").fadeIn(500);					
				},500);				
			}
			else{
				$rootScope.isNextButtonDisabled = true;
			}
            $rootScope.createaAssesment();
            //$rootScope.assesmentAttempted++;
        }
    }
});

FrameworkApp.directive('bindHtmlCompile', ['$compile', function ($compile) {
    return {
        restrict: 'A',
        link: function (scope, element, attrs) {
            scope.$watch(function () {
                return scope.$eval(attrs.bindHtmlCompile);
            }, function (value) {
                // In case value is a TrustedValueHolderType, sometimes it
                // needs to be explicitly called into a string in order to
                // get the HTML string.
                element.html(value && value.toString());
                // If scope is provided use it, otherwise use parent scope
                var compileScope = scope;
                if (attrs.bindHtmlScope) {
                    compileScope = scope.$eval(attrs.bindHtmlScope);
                }
                $compile(element.contents())(compileScope);
            });
        }
    };
}]);





